/*****************************************************
This program was produced by the
CodeWizardAVR V2.04.8a Standard
Automatic Program Generator
 Copyright 1998-2010 Pavel Haiduc, HP InfoTech s.r.l.
http://www.hpinfotech.com
--------------------------------------------------------
Project : PPE robot suiveur de ligne 
Version : 2.2.0
Date de cration   : 19/03/2008
Dernire mise  jour :  03/05/2011
Author  : Philippe Mariano
Company : Lyce Pierre Emile Martin
--------------------------------------------------------                             
Comments:  
Les LED et le clavier sont commands par I2C soft.
A l'arrt: Modification des paramtres PWM sur le robot,
test des servos, test des moteurs, test du capteur ligne
et test du capteur constitu de 5 cellules infrarouge,
informations (Nom du robot, version, date de rvision
etc.)
En dplacement: Affichage de la position du robot par 
rapport  la ligne sur les cinq LED de droite.
Affichage Erreur de mesure sur les trois LED de gauche
Arrt devant la cible et tir (compilation conditionnelle)  
--------------------------------------------------------
Chip type               : ATmega32
Program type            : Application
AVR Core Clock frequency: 8,000000 MHz
Memory model            : Small
External RAM size       : 0
Data Stack size         : 512
*****************************************************/

#include <mega32.h>

// !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!  
// !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
// ATTENTION : Fichier principal du projet (Ne pas modifier)  
// !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
// !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!


//============================================================================================================
// Bibliothques   
//------------------------------------------------------------------------------------------------------------ 
// En tte des bibliothques CVAVR situes dans le rpertoire \CVAVR\INC, bibliothques dans \CVAVR\lib
//------------------------------------------------------------------------------------------------------------
#include <delay.h>
#include <stdio.h>       
#include <stdlib.h>
#include <string.h>
#include <math.h>
//------------------------------------------------------------------------------------------------------------
// En tte des bibliothques dveloppes pour la carte SISI situes dans le rpertoire du projet
//------------------------------------------------------------------------------------------------------------ 
#include "PCF8574.h"        // Contient les fonctions: Ecrire_Port_I2C_Soft, Lire_Port_I2C_Soft 

#include "RB220.h"          // Paramtrage de la programmation

#include "SISI2SVL.h"       // Contient les fonctions: Lire_BP_I2C_Soft, Affiche_LCD, Arret_Moteurs,  
                            // Active_Moteurs, Affiche_Fleche     
                            
#include "RBELEVE.h"        // Contient la dclaration du sous-programme Mode_Run()
//============================================================================================================
// Transfert IBM
#define ClkIBM  PORTD.1
#define DataIBM PORTD.0
//============================================================================================================
// Dclarations  
//------------------------------------------------------------------------------------------------------------
// I2C Bus functions
#asm
   .equ __i2c_port=0x18
   .equ __sda_bit=1
   .equ __scl_bit=0
#endasm
#include <i2c.h>

// Alphanumeric LCD Module functions   
#asm
   .equ __lcd_port=0x15
#endasm
#include <lcd.h>  
//============================================================================================================

//============================================================================================================
// 1) CONSTANTES
//------------------------------------------------------------------------------------------------------------
// 11)Constantes en flash
//------------------------------------------------------------------------------------------------------------
// Infos 
//------------------------------------------------------------------------------------------------------------
flash struct Infos {
          char PremiereLigne[17];
        } TableInfos[] = { "I1> <DESIGN1>   ",
                           "I2> Vers=2.0.0b ",
                           "I3> 03/05/2011  ",
                           #if POSITIONCONNECTEUR==CONNECTEURAV
                           "I4> Connect=AV  ",
                           #else
                           "I4> Connect=AR  ",
                           #endif
                           #if PARCOURS_ROBOT==SANS_ARRET 
                           "I5> Arret= NON  ", 
                           #else  
                           "I5> Arret= OUI  ", 
                           #endif
                           #if FS11==SOLUTIONELEVE
                           "I6> FS11=ELEVE  ",
                           #else
                           "I6> FS11=PROF   ",
                           #endif
                           #if FS12==SOLUTIONELEVE
                           "I7> FS12=ELEVE  ",
                           #else
                           "I7> FS12=PROF   ",
                           #endif
                           #if FS13==SOLUTIONELEVE
                           "I8> FS13=ELEVE  ",
                           #else
                           "I8> FS13=PROF   ",
                           #endif
                         };
//------------------------------------------------------------------------------------------------------------
// Texte des sous-menus " Rglage des paramtres PWM "  
//------------------------------------------------------------------------------------------------------------
flash struct Affichage_reglages {
        char ligne0[12]; // 12 caractres + fin de ligne arrondi  l'entier pair suprieur
        char ligne1[12]; // Ligne0 = 1er ligne de l'affichage 
        } Tab_Aff_Reg[11]= {{"Centre MG =","Centre MD ="},
                    {"Droite MG =","Droite MD ="},
                    {"Droite+ MG=","Droite+ MD="},
                    {"Droit2+ MG=","Droit2+ MD="},
                    {"Droit3+ MG=","Droit3+ MD="},
                    {"Droit4+ MG=","Droit4+ MD="},
                    {"Gauche MG =","Gauche MD ="},
                    {"Gauche+ MG=","Gauche+ MD="},
                    {"Gauch2+ MG=","Gauch2+ MD="},
                    {"Gauch3+ MG=","Gauch3+ MD="},
                    {"Gauch4+ MG=","Gauch4+ MD="}};

//------------------------------------------------------------------------------------------------------------
// Messages pour le LCD
//------------------------------------------------------------------------------------------------------------
flash char *Texte_Accueil_Ligne0 	= "    V_2_2_0b    ";
flash char *Texte_Accueil_Ligne1 	= "  [03/05/2011]  ";
flash char *TexteMenuCoefMot        = "1.Regl coef Mot ";
flash char *TexteMenuActiveRobot    = "2.Activ. Robot  ";
flash char *TexteMenuTestTRobot     = "3.Test du Robot ";
flash char *TexteMenuInfos          = "4.Informations  ";
flash char *TexteMenuTestServos     = "3.1 Test Servos ";
flash char *TexteMenuTestMoteurs    = "3.2 Tst Moteurs ";
flash char *TexteMenuTestCaptLigne  = "3.3 Tst CptLign ";
flash char *TexteMenuTestCaptCible  = "3.4 Tst CptCibl ";
flash char *TexteMenuTestTransmIBM  = "3.5 Tst Tx IBM  ";
flash char *Ligne1ChoixEntr	        = "         [Entr] ";
flash char *Ligne1ChoixEchap	    = "        [Echap] ";
//------------------------------------------------------------------------------------------------------------
// Tables des caractres personnaliss:  placer dans la mmoire CGRAM du LCD  
//------------------------------------------------------------------------------------------------------------
flash unsigned char flecheHaut[] = {0x04, 0x0E, 0x15, 0x04, 0x04, 0x04, 0x04, 0x00};    // @1 CGRAM
flash unsigned char flecheBas[] = {0x04, 0x04, 0x04, 0x04, 0x15, 0x0E, 0x04, 0x00};     // @2 CGRAM
//------------------------------------------------------------------------------------------------------------
// 12) Constantes en RAM
//------------------------------------------------------------------------------------------------------------                                
// Table de transcodage: Table_Calcul_OCR1x_PROF 
// Rle: Effectue le transcodage rapport cyclique alpha(%) -> valeur registre OCR1x
//------------------------------------------------------------------------------------------------------------
flash unsigned char Table_Calcul_OCR1x_PROF[21][2]={{0,0},{5,13},{10,25},{15,38},{20,51},{25,64},{30,76},
{35,89},{40,102},{45,115},{50,128},{55,140},{60,153},{65,166},{70,179},{75,191},{80,205},{85,219},
{90,233},{95,233},{100,253}};

//------------------------------------------------------------------------------------------------------------ 
//============================================================================================================

//============================================================================================================
// Variables globales
//============================================================================================================ 
// 1) Variables sauvegardes en eeprom
//------------------------------------------------------------------------------------------------------------
// Table des coefficients de rglage des signaux PWM (en %)  ( initialiser avec le fichier EEPROMROBOTBASE.eep 
// lors de la premire mise en oeuvre du robot (Voir prof)
//------------------------------------------------------------------------------------------------------------ 
eeprom unsigned char PWM_EEPROM[11][2];
// Organisation de la table    PWM_EEPROM[11][2]  
//    Position     MG    MD
//   n          [n,0] [n,1]
// Centre       val00  val01
// Droite
// Droite+
// Droite2+
// Droite3+
// HorsLigneD
// Gauche
// Gauche+
// Gauche2+
// Gauche3+
// HorsLigneG
//------------------------------------------------------------------------------------------------------------ 
// 2) Variables en RAM
//------------------------------------------------------------------------------------------------------------
// Table des coefficients de rglage des signaux PWM (en %) utiliss pour la correction de trajectoire
unsigned char PWM[11][2];		// Contient les coefficients destins au Timers(PWM) pour le rglage de la 
								// frquence de rotation des moteurs.  
//------------------------------------------------------------------------------------------------------------
// Diffrents tats du graphe des transitions (menus)                                        
enum TMenu {Menu_Reglages, Menu_Run, Menu_Tests, Menu_Infos, Menu_Test_Servos, Menu_Test_Moteurs, Cde_Moteurs,  
       Reglage_PWM, Activation, Menu_Test_Capteurs_Ligne, Menu_Test_Capteurs_Cible, Menu_Test_Transm_IBM,
       Transm_IBM, Menu_Affiche_Infos, Affiche_Reglages, Cde_Servo, Visu_Position,Visu_Cible} 
       Menu=Menu_Reglages, Menu_1=Menu_Run;          
//------------------------------------------------------------------------------------------------------------
// Pour la dtection de la cible (utilis dans INT0, dans le menu VisuCible et par le SP Mode_RUN) 
//------------------------------------------------------------------------------------------------------------
bit Cible = 0;                              // cible = 0 => pas de dtection, cible = 1 => dtection 
#if PARCOURS_ROBOT == AVEC_ARRET 
bit Cible_1 = 1;                            // Utiliser par le test du capteur ( l'arrt)     
#endif
//============================================================================================================

//============================================================================================================
// Sous programme d'interruption dclench sur un front descendant de INT0 
// (Dtection de la cible par un contact reed ferm par la prsence d'un aimant)
//------------------------------------------------------------------------------------------------------------
// External Interrupt 0 service routine
interrupt [EXT_INT0] void ext_int0_isr(void)
{
// Dsactivation de l'INT0
GICR=0x00; // Dsactivation INT0 (bit6 de GICR)
Arret_Moteurs();  // Arrt du robot
Cible = 1; 
}
//============================================================================================================  
// Prototype des fonctions en cours de test
void IBMTransfertChar(unsigned char Valeur);      // Transfert d'un octet dans une trame IBM PS2

//============================================================================================================  
//============================================================================================================
// Programme principal
//============================================================================================================
//============================================================================================================
void main(void)
{ // Dbut du main
//============================================================================================================
// Variables locales  la fonction principale 
//------------------------------------------------------------------------------------------------------------
// type                   nom                                   Commentaires
//------------------------------------------------------------------------------------------------------------
unsigned char BP=0, Code_BP=0;                           // Etat des boutons-poussoirs de la carte SISI
unsigned char i=0, j=0, k=0;                                 // Compteur d'usage gnral
unsigned char j_n=0, j_n_1=1;
unsigned char NumServo=1, NumServo_1=1;             // Saisie du numro du servo
unsigned char Aff_Cde_Servo=0, Aff_Cde_Servo_1=0;   // Valeur  envoyer au servo slectionn dans le menu Cde_Servo  
unsigned char decompte=5, decompte_1=5;             // Temporisation avant le passage en mode RUN
int i_n=0, i_n_1=1;                                 // Indices du tableau des structures d'affichage
unsigned char PositionRobotSVL = POS_HORS_LIGNE, PositionRobotSVL_1 = AR_GAUCHE_OU_AV_DROITE_3PLUS;
unsigned char VisuPositionSurLED;   
char display_buffer_ligne0[17];                     // Tampon ligne 0 de l'afficheur LCD (16 caractres + /0)
char display_buffer_ligne1[17];                     // Tampon ligne 1 de l'afficheur LCD            "
char pourcentage0[3], pourcentage1[3];              // Affichage pourcentage PWM (0->95) (2 caractres + /0)
char *AffichePositionRobot;
unsigned char rcycl=0, rcycl_1=0;                   // Saisie du rapport cyclique lors d'une modification manuelle
//------------------------------------------------------------------------------------------------------------
// Tableau des coefficients placs dans OCR1x pour le test "rglage du rapport cyclique du signal PWM"
unsigned char alpha[11] = {0,25,51,76,102,127,153,178,204,229,255};
//------------------------------------------------------------------------------------------------------------ 
// Gestion du protocole IBM
//------------------------------------------------------------------------------------------------------------
// Construction d'un octet avec le clavier
unsigned char MSByteIBM=0, LSByteIBM=0;
unsigned char QuartetIBM=0, AffQuartet_1 = 'L', AffQuartet = 'L'; 
// Transfert 
unsigned int TrameIBM=0;
unsigned char CodeIBM_1=0, CodeIBM = 0;
//============================================================================================================

//============================================================================================================
// Initialisations
//------------------------------------------------------------------------------------------------------------
// Initialisation des priphriques
//------------------------------------------------------------------------------------------------------------                                        
// Input/Output Ports initialization
// Port A initialization
// Func0=Out Func1=Out Func2=Out Func3=Out Func4=Out Func5=Out Func6=Out Func7=Out 
// State0=1 State1=1 State2=1 State3=1 State4=1 State5=1 State6=1 State7=1 
                    // Gestion des Emetteurs_IR 
PORTA=0xFF;         // Dsactivation des E_IR  la mise sous tension
DDRA=0xFF;          // Port en sortie
//------------------------------------------------------------------------------------------------------------
// Port B initialization
// Func0=In Func1=In Func2=In Func3=In Func4=In Func5=In Func6=Out Func7=Out
// State0=T State1=T State2=T State3=T State4=T State5=T State6=0 State7=0
PORTB=0x00;        // SERVO1 sur PB6, SERVO2 sur PB7
DDRB=0xC0;
//------------------------------------------------------------------------------------------------------------
// Port C initialization
// Func0=In Func1=In Func2=In Func3=In Func4=In Func5=In Func6=In Func7=In 
// State0=T State1=T State2=T State3=T State4=T State5=T State6=T State7=T 
                    // Gestion de l'afficheur LCD
PORTC=0x00;         // Gre l'affichage, initialis par la fonction lcd_init(16);
DDRC=0x00;    
//------------------------------------------------------------------------------------------------------------
// Port D initialization
// Func7=Out Func6=Out Func5=Out Func4=Out Func3=In Func2=In Func1=Out Func0=Out 
// State7=0 State6=0 State5=1 State4=1 State3=T State2=T State1=1 State0=1 

                    // Capteur magntique, moteurs, S4 et liaison srie
PORTD=0x33;         // Capteur magntique reli au 0V sur PD2
DDRD=0xF3;          // Broches PWM moteurs droit et gauche en sortie, initialise  1 
                    // Cde Servo 1 et 2 en sortie, Initialises  0
                    // ClkIBM et DataIBM en sortie, Initialiss  1
//------------------------------------------------------------------------------------------------------------
// Timer/Counter 1 initialization
// Clock source: System Clock
// Clock value: 8000,000 kHz
// Mode: Ph. correct PWM top=00FFh
// OC1A output: Inverted
// OC1B output: Inverted
// Noise Canceler: Off
// Input Capture on Falling Edge
TCCR1A=0xF1; // 0xA1 pour robot 2008, 0xF1 pour robot 2009
TCCR1B=0x01;
TCNT1H=0x00;
TCNT1L=0x00;
OCR1AH=0x00;
OCR1AL=0x00;
OCR1BH=0x00;
OCR1BL=0x00;
//------------------------------------------------------------------------------------------------------------
// External Interrupt(s) initialization
// INT0: On
// INT0 Mode: Falling Edge
// INT1: Off
// INT2: Off
GICR|=0x40;
MCUCR=0x02;
MCUCSR=0x00;
GIFR=0x40;
//------------------------------------------------------------------------------------------------------------
// Analog Comparator initialization
// Analog Comparator: On
// Analog Comparator Input Capture by Timer/Counter 1: Off
// Analog Comparator Output: Off
ACSR=0x00;
SFIOR=0x00;
//------------------------------------------------------------------------------------------------------------
// LCD module initialization
lcd_init(16);
//------------------------------------------------------------------------------------------------------------
// Chargement initial de la mmoire CGRAM de l'afficheur avec deux caractres personaliss  
//------------------------------------------------------------------------------------------------------------
for (i=0;i<8;i++)
{
 lcd_write_byte(Add_FlecheH_CGRAM + i, flecheHaut[i]);      // @1 Caractre flche haut
 lcd_write_byte(Add_FlecheB_CGRAM + i, flecheBas[i]);       // @2 Caractre flche bas
}
//----------------------------------------------------------------------------------------------------------------------------------
// Initialisation de la position des Servos
CDE_SERVO1 = 0;
CDE_SERVO2 = 0;
//----------------------------------------------------------------------------------------------------------------------------------
//----------------------------------------------------------------------------------------------------------------------------------
// Message d'accueil
//----------------------------------------------------------------------------------------------------------------------------------
lcd_clear();
sprintf(display_buffer_ligne0,Texte_Accueil_Ligne0); // Version du logiciel  remplacer par le nom du robot
sprintf(display_buffer_ligne1,Texte_Accueil_Ligne1);
Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);   
delay_ms(3000);
//================================================================================================================================== 

//==================================================================================================================================
// Boucle principale
//----------------------------------------------------------------------------------------------------------------------------------
while (1)
{    
  BP = Lire_BP_I2C_Soft();                          // Lecture BP pour volution du graphe des menus 
                                                    // Gestion anti-rebonds     
  Code_BP =  Lire_Port_I2C_Soft(Add_BP_I2C);        // Lecture BP pour affichage sur les LED
                                                    // Code BP = Code LED
   
  switch (Menu)
   { // Dbut du switch principal    
//==================================================================================================================================
// Dbut Menus  
///=================================================================================================================================
// Dbut de menus de NIVEAU 1 
// Menu 1 : Rglage des coefficients moteur
//----------------------------------------------------------------------------------------------------------------------------------
      case Menu_Reglages :  if (Menu_1 != Menu)
                             {
                                sprintf(display_buffer_ligne0,TexteMenuCoefMot);
                                sprintf(display_buffer_ligne1,Ligne1ChoixEntr);
                                Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
                                Affiche_Fleche();
                             }
                      
                            switch(BP)
                             {                                   
                                case FlecheH_I2C: Menu = Menu_Infos;  break; // touche [flche bas]
                                case FlecheB_I2C: Menu = Menu_Run;  break; // touche [flche haut]  
                                case ENTR_I2C: Menu = Affiche_Reglages;  break; // touche [Enter]
                                default: Menu = Menu_Reglages;
                                }
                       
                            Menu_1 = Menu_Reglages;
       break; 
//---------------------------------------------------------------------------------------------------------------------------------- 
// Menu 2 : Activation Robot 
//----------------------------------------------------------------------------------------------------------------------------------     
       case Menu_Run :      if (Menu_1 != Menu)
                             {
                                sprintf(display_buffer_ligne0,TexteMenuActiveRobot);
                                sprintf(display_buffer_ligne1,Ligne1ChoixEntr);
                                Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
                                Affiche_Fleche();
                             }
                      
                            switch(BP)
                             {         
                                case FlecheH_I2C: Menu = Menu_Reglages; break; // touche [flche bas]
                                case FlecheB_I2C: Menu = Menu_Tests; break; // touche [flche haut]
                                case ENTR_I2C: Menu = Activation; IBMTransfertChar(0x70);break; // touche [Enter]
                                default: Menu = Menu_Run;
                             }
                       
                            Menu_1 = Menu_Run;
       break;      
//----------------------------------------------------------------------------------------------------------------------------------
// Menu 3 : Test du robot
//----------------------------------------------------------------------------------------------------------------------------------       
       case Menu_Tests :    if (Menu_1 != Menu)
                             {
                                sprintf(display_buffer_ligne0,TexteMenuTestTRobot);
                                sprintf(display_buffer_ligne1,Ligne1ChoixEntr);
                                Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
                                Affiche_Fleche();
                             } 
                       
                            switch(BP)
                             {                                  
                                case FlecheH_I2C: Menu = Menu_Run;  break; // touche [flche bas]
                                case FlecheB_I2C: Menu = Menu_Infos;  break; // touche [flche haut]
                                case ENTR_I2C: Menu = Menu_Test_Servos;  break; // touche [Enter]
                                default: Menu = Menu_Tests ;
                             }
                       
                            Menu_1 = Menu_Tests;
       
       break;
//---------------------------------------------------------------------------------------------------------------------------------- 
// Menu 4 : Informations
//----------------------------------------------------------------------------------------------------------------------------------      
       case Menu_Infos :  if (Menu_1 != Menu)
                             {
                                sprintf(display_buffer_ligne0,TexteMenuInfos);
                                sprintf(display_buffer_ligne1,Ligne1ChoixEntr);
                                Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
                                Affiche_Fleche();
                             }
                      
                            switch(BP)
                             {                                   
                                case FlecheH_I2C: Menu = Menu_Tests;  break; // touche [flche bas]
                                case FlecheB_I2C: Menu = Menu_Reglages;  break; // touche [flche haut]  
                                case ENTR_I2C: j_n = 0; Menu = Menu_Affiche_Infos;  break; // touche [Enter]
                                default: Menu = Menu_Infos;
                                }
                       
                            Menu_1 = Menu_Infos;
       break;  
//----------------------------------------------------------------------------------------------------------------------------------          
// Fin Menus de NIVEAU 1 
//================================================================================================================================== 
//==================================================================================================================================   
// Dbut des sous-menus (NIVEAU 2)
//================================================================================================================================== 
// Sous-menu 3.1 : Test des servos
//----------------------------------------------------------------------------------------------------------------------------------    
       case Menu_Test_Servos : if (Menu_1 != Menu)
                                {
                                    sprintf(display_buffer_ligne0,TexteMenuTestServos);
                                    sprintf(display_buffer_ligne1,Ligne1ChoixEntr);
                                    Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
                                    Affiche_Fleche();
                                }
                      
                              switch(BP)
                                {                                  
                                     case FlecheH_I2C: Menu = Menu_Test_Transm_IBM;  break;     // touche [flche bas]
                                     case FlecheB_I2C: Menu = Menu_Test_Moteurs;  break;            // touche [flche haut]
                                     case ECHAP_I2C: Menu = Menu_Tests; break;                      // touche [Echap]
                                     case ENTR_I2C: Menu = Cde_Servo;                               // touche [Enter] 
                                                     Aff_Cde_Servo = Aff_Valeur_Cde_SERVO1;  
                                     break;             
                                     default: Menu = Menu_Test_Servos;
                                }
                       
                              Menu_1 = Menu_Test_Servos;
       break; 
//----------------------------------------------------------------------------------------------------------------------------------
// Sous-menu 3.2 :  Test des moteurs
//----------------------------------------------------------------------------------------------------------------------------------  
       case Menu_Test_Moteurs : if (Menu_1 != Menu)
                                 { 
                                    sprintf(display_buffer_ligne0,TexteMenuTestMoteurs);
                                    sprintf(display_buffer_ligne1,Ligne1ChoixEntr);
                                    Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
                                    Affiche_Fleche();
                                 }  
                         
                                switch(BP)
                                 {   
                                    case FlecheH_I2C: Menu = Menu_Test_Servos;  break; // touche [flche bas]  
                                    case FlecheB_I2C: Menu = Menu_Test_Capteurs_Ligne;  break; // touche [flche haut]
                                    case ECHAP_I2C: Menu = Menu_Tests; break; // touche [Echap]                          
                                    case ENTR_I2C: rcycl = 0; rcycl_1 = 0; Menu = Cde_Moteurs;  break; // touche [Enter] 
                                    default: Menu = Menu_Test_Moteurs;
                                 }
                       
                                Menu_1 = Menu_Test_Moteurs;    
       break;
//----------------------------------------------------------------------------------------------------------------------------------
// Sous-menu 3.3 :  Test du capteur ligne
//----------------------------------------------------------------------------------------------------------------------------------        
       case Menu_Test_Capteurs_Ligne :  if (Menu_1 != Menu)
                                            { 
                                                sprintf(display_buffer_ligne0,TexteMenuTestCaptLigne);
                                                sprintf(display_buffer_ligne1,Ligne1ChoixEntr);
                                                Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
                                                Affiche_Fleche();
                                            }
                              
                                        switch(BP)
                                            { 
                                                case FlecheH_I2C: Menu = Menu_Test_Moteurs;  break;     // touche [flche bas]
                                                case FlecheB_I2C: Menu = Menu_Test_Capteurs_Cible;  break;     // touche [flche haut]
                                                case ECHAP_I2C: Menu = Menu_Tests; break;             // touche [Echap]                                 
                                                case ENTR_I2C: Menu = Visu_Position;  break;         // touche [Enter] 
                                                default: Menu = Menu_Test_Capteurs_Ligne;
                                            }
                       
                                        Menu_1 = Menu_Test_Capteurs_Ligne;    
        break; 
//----------------------------------------------------------------------------------------------------------------------------------
// Sous-menu 3.4 : Test du capteur cible
//----------------------------------------------------------------------------------------------------------------------------------          
        case Menu_Test_Capteurs_Cible : if (Menu_1 != Menu)
                                         { 
                                            sprintf(display_buffer_ligne0,TexteMenuTestCaptCible);
                                            sprintf(display_buffer_ligne1,Ligne1ChoixEntr);
                                            Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
                                            Affiche_Fleche();
                                         }
                              
                                        switch(BP)
                                         { 
                                            case FlecheH_I2C: Menu = Menu_Test_Capteurs_Ligne;  break;     // touche [flche bas]
                                            case FlecheB_I2C: Menu = Menu_Test_Transm_IBM;  break;     // touche [flche haut]
                                            case ECHAP_I2C: Menu = Menu_Tests; break;             // touche [Echap]                                 
                                            case ENTR_I2C: Menu = Visu_Cible;                     // touche [Enter] 
                                                     #if PARCOURS_ROBOT == AVEC_ARRET  
                                                     #asm("sei");
                                                     #endif
                                            break;     
                                            default: Menu = Menu_Test_Capteurs_Cible;
                                         }
                       
                                        Menu_1 = Menu_Test_Capteurs_Cible;    
        break;   
//----------------------------------------------------------------------------------------------------------------------------------
// Sous-menu 3.5 : Test transmission protocole IBM (vers carte MicroDesign)
//----------------------------------------------------------------------------------------------------------------------------------
 case Menu_Test_Transm_IBM : if (Menu_1 != Menu)
                                         { 
                                            sprintf(display_buffer_ligne0,TexteMenuTestTransmIBM);
                                            sprintf(display_buffer_ligne1,Ligne1ChoixEntr);
                                            Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
                                            Affiche_Fleche();
                                         }
                              
                                        switch(BP)
                                         { 
                                            case FlecheH_I2C: Menu =  Menu_Test_Capteurs_Cible ;  break;     // touche [flche bas]
                                            case FlecheB_I2C: Menu = Menu_Test_Servos;  break;     // touche [flche haut]
                                            case ECHAP_I2C: Menu = Menu_Tests; break;             // touche [Echap]                                 
                                            case ENTR_I2C: Menu = Transm_IBM;                     // touche [Enter]      
                                            break;     
                                            default: Menu = Menu_Test_Transm_IBM;
                                         }
                       
                                        Menu_1 = Menu_Test_Transm_IBM;    
        break; 
//----------------------------------------------------------------------------------------------------------------------------------           
// Fin des sous-menus (NIVEAU 2) 
//==================================================================================================================================
// Fin Menus 
//==================================================================================================================================
// Dbut des affichages  
//----------------------------------------------------------------------------------------------------------------------------------        
// Affichage des rglages PWM sous la forme d'un menu droulant
       case Affiche_Reglages :  if ((Menu_1 != Menu) || (i_n_1 != i_n))   
                                {
                                    if (fmod(i_n,2)==0) // Cas1: si l'indice i_n permettant de parcourir le tableau AFFICHE_REGLAGE est pair
                                    {   // Cas1: Affichage ligne (i_n/2) colonne 0 sur ligne 0 afficheur
                                        sprintf(display_buffer_ligne0,Tab_Aff_Reg[i_n/2].ligne0); 
                                        itoa(PWM_EEPROM[i_n/2][0],pourcentage0);
                                        strcat(display_buffer_ligne0,pourcentage0);
                                        // Cas1: Affichage ligne (i_n/2) colonne 1 sur ligne 1 afficheur
                                        sprintf(display_buffer_ligne1,Tab_Aff_Reg[i_n/2].ligne1); 
                                        itoa(PWM_EEPROM[i_n/2][1],pourcentage1);
                                        strcat(display_buffer_ligne1,pourcentage1);
                                    }  
                                    
                                    else  // si l'indice i_n permettant de parcourir le tableau AFFICHE_REGLAGE est impair
                                    {   // Cas2et3: Affichage ligne (i_n/2) colonne 1 sur ligne 0 afficheur
                                        sprintf(display_buffer_ligne0,Tab_Aff_Reg[i_n/2].ligne1);  
                                        itoa(PWM_EEPROM[i_n/2][1],pourcentage0);
                                        strcat(display_buffer_ligne0,pourcentage0);

                                        if (i_n < 21) // et si la fin de la table AFFICHE_REGLAGE n'est pas atteinte 
                                            {   // cas2: Affichage ligne ((i_n/2)+1) colonne 0 sur ligne 1 afficheur  
                                                sprintf(display_buffer_ligne1,Tab_Aff_Reg[(i_n/2)+1].ligne0);
                                                itoa(PWM_EEPROM[(i_n/2)+1][0],pourcentage1);
                                                strcat(display_buffer_ligne1,pourcentage1);
                                            }
                                        else // et si la fin de la table AFFICHE_REGLAGE est atteinte 
                                            {   // cas3: Affichage ligne 0 colonne 0 sur ligne 1 afficheur
                                                sprintf(display_buffer_ligne1,Tab_Aff_Reg[0].ligne0); 
                                                itoa(PWM_EEPROM[0][0],pourcentage1);
                                                strcat(display_buffer_ligne1,pourcentage1);
                                            }
                                    }
                                    Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
                                    lcd_gotoxy(14,0); lcd_putchar('%');
                                    lcd_gotoxy(15,0);    // Affichage flecheHaut
                                    lcd_putchar(Caractere_FlecheH);
                                    lcd_gotoxy(14,1); lcd_putchar('%');    
                                    lcd_gotoxy(15,1);    // Affichage flecheBas
                                    lcd_putchar(Caractere_FlecheB);
                                    i_n_1 = i_n; // Notifie que l'affichage a chang
                                 }
                      
                                switch(BP)
                                { 
                                    // Gestion de l'indice i_n du tableau AFFICHE_REGLAGE dans l'intervalle [0,21]
                                    case FlecheH_I2C: if (i_n < 21) i_n++; else i_n=0; break;   // touche [flche haut]
                                    case FlecheB_I2C: if (i_n > 0) i_n--; else i_n=21; break;   // touche [flche bas]
                                    case ECHAP_I2C: Menu = Menu_Reglages; break;                // touche [Echap]
                                            // La touche [Enter] fait passer la donne prsente sur la premire 
                                            // ligne de l'afficheur en mode modification                                 
                                    case ENTR_I2C:  if (fmod(i_n,2)==0) // si i_n pair     
                                                        rcycl = PWM_EEPROM[i_n/2][0];
                                                    else  // si i_n impair   
                                                        rcycl = PWM_EEPROM[i_n/2][1];
                                                    Menu = Reglage_PWM;  
                                    break;  
                                    default: Menu = Affiche_Reglages;
                                }
                       
                              Menu_1 = Affiche_Reglages;
       break;
//----------------------------------------------------------------------------------------------------------------------------------
//----------------------------------------------------------------------------------------------------------------------------------       
       case Menu_Affiche_Infos : if ((Menu_1 != Menu) || (j_n != j_n_1))
                                {
                                    sprintf(display_buffer_ligne0,TableInfos[j_n].PremiereLigne);
                                    sprintf(display_buffer_ligne1,Ligne1ChoixEchap);
                                    Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
                                    Affiche_Fleche();
                                    j_n_1 = j_n;
                                }
                      
                              switch(BP)
                                {                                  
                                     case FlecheH_I2C: if (j_n > 0) j_n--; else j_n = (sizeof(TableInfos)/17)-1;  break;     // touche [flche bas]
                                     case FlecheB_I2C: if (j_n < ((sizeof(TableInfos)/17)-1)) j_n++; else j_n = 0;  break;   // touche [flche haut]
                                     case ECHAP_I2C: Menu = Menu_Infos; break;                      // touche [Echap]
                                     default: Menu = Menu_Affiche_Infos;
                                }
                       
                              Menu_1 = Menu_Affiche_Infos;
       
       break;   
// ---------------------------------------------------------------------------------------------------------------------------------
// Fin des affichages
//================================================================================================================================== 
// Dbut des tests et rglages avant le dpart
//================================================================================================================================== 
// Rglage des coefficients PWM sauvegards en EEPROM
// ---------------------------------------------------------------------------------------------------------------------------------   
        case Reglage_PWM :  if ((Menu_1 != Menu)|| (rcycl_1 != rcycl))
                            { 
                                if (fmod(i_n,2)==0) // si i_n pair
                                { 
                                    sprintf(display_buffer_ligne0,Tab_Aff_Reg[i_n/2].ligne0);
                                    itoa(rcycl,pourcentage0);
                                    strcat(display_buffer_ligne0,pourcentage0);
                                }
                                else  // si i_n impair
                                {
                                    sprintf(display_buffer_ligne0,Tab_Aff_Reg[i_n/2].ligne1);
                                    itoa(rcycl,pourcentage0);
                                    strcat(display_buffer_ligne0,pourcentage0);
                                }
                                sprintf(display_buffer_ligne1,"ENTR>Memo [ECH]");
                                Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
                                lcd_gotoxy(15,0); lcd_putchar('+');
                                lcd_gotoxy(15,1); lcd_putchar('-');
                                rcycl_1 = rcycl; // Notifie que l'affichage a chang
                            }
                      
                            switch(BP)
                            {   // Rglage du rapport cyclique par pas de 5%
                                case MOINS_I2C: if (rcycl > 5) rcycl = rcycl-5; else rcycl = 0; break; // touche [-] 
                                case PLUS_I2C:  if (rcycl < 100) rcycl = rcycl+5; else rcycl = 100; break; // touche [+]
                                case ECHAP_I2C: Menu = Affiche_Reglages;  break; // touche [Echap]
                                case ENTR_I2C:  if (fmod(i_n,2)==0)             // si i_n pair touche [Entr]
                                                    PWM_EEPROM[i_n/2][0]=rcycl;
                                                else                            // si i_n impair
                                                    PWM_EEPROM[i_n/2][1]=rcycl;
                                      
                                                Menu = Affiche_Reglages;     
                                break;                                  
                                default: Menu = Reglage_PWM;
                            }
                       
                            Menu_1 = Reglage_PWM;
       break;  
// -----------------------------------------------------------------------------------------------------------        
// Commande manuelle des servos 1 et 2
// -----------------------------------------------------------------------------------------------------------        
      case Cde_Servo : if ((Menu_1 != Menu) || (NumServo != NumServo_1)|| (Aff_Cde_Servo != Aff_Cde_Servo_1))
                        {
                            sprintf(display_buffer_ligne0,"Cde Servo_%-u= %-u   ",NumServo,Aff_Cde_Servo);
                            sprintf(display_buffer_ligne1,"[+] [-] [Echp]  ");
                            Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
                            Affiche_Fleche();
                            NumServo_1 = NumServo; // Notifie que l'affichage a chang
                            Aff_Cde_Servo_1 = Aff_Cde_Servo;
                        }
                       
                       switch(BP)
                        { 
                            case MOINS_I2C:                                     // touche [-]
                                    if (NumServo==1) {CDE_SERVO1 = 0; Aff_Cde_Servo = Aff_Valeur_Cde_SERVO1;}                    
                                    if (NumServo==2) {CDE_SERVO2 = 0; Aff_Cde_Servo = Aff_Valeur_Cde_SERVO2;}    
                            break; 
                            
                            case PLUS_I2C:                                      // touche [+]
                                    if (NumServo==1) {CDE_SERVO1 = 1; Aff_Cde_Servo = Aff_Valeur_Cde_SERVO1;}                    
                                    if (NumServo==2) {CDE_SERVO2 = 1; Aff_Cde_Servo = Aff_Valeur_Cde_SERVO2;}
                            break; 

                            case ECHAP_I2C: CDE_SERVO1 = 0; CDE_SERVO2 = 0;     // touche [Echap] 
                                            Menu = Menu_Test_Servos; 
                            break;
                             
                            case FlecheB_I2C:   if (NumServo == 1) {NumServo = 2; Aff_Cde_Servo = Aff_Valeur_Cde_SERVO2;}
                                                    else if (NumServo == 2) {NumServo = 1; Aff_Cde_Servo = Aff_Valeur_Cde_SERVO1;}
                            break;
                             
                            case FlecheH_I2C:   if (NumServo == 1) {NumServo = 2; Aff_Cde_Servo = Aff_Valeur_Cde_SERVO2;}
                                                    else if (NumServo == 2) {NumServo = 1; Aff_Cde_Servo = Aff_Valeur_Cde_SERVO1;}
                            break;
                             
                            default: Menu = Cde_Servo;
                        } 
                           
                        Menu_1 = Cde_Servo;
      break;
// -----------------------------------------------------------------------------------------------------------        
// Commande manuelle des moteurs D et G
// -----------------------------------------------------------------------------------------------------------        
      case Cde_Moteurs :  if ((Menu_1 != Menu)|| (rcycl_1 != rcycl))
                            {
                                sprintf(display_buffer_ligne0,"Rap. cycl = %-u%%",rcycl);
                                sprintf(display_buffer_ligne1,"[+] [-] [Echap] ");
                                Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1); 
                                rcycl_1 = rcycl; 
                            }   
              
                            switch(BP)
                            {  
                                case MOINS_I2C: if (rcycl > 10) rcycl = rcycl-10; else rcycl = 0; break; // touche [-]
                                case PLUS_I2C: if (rcycl < 90) rcycl = rcycl+10; else rcycl = 100; break; // touche [+]
                                case ECHAP_I2C : rcycl = 0; Menu = Menu_Test_Moteurs; break; // touche [Echap]
                                default: Menu = Cde_Moteurs;
                            }
                                 
                            // Transfert des rapports cycliques vers les registres     
                            OCR1AL=alpha[rcycl/10];
                            OCR1BL=alpha[rcycl/10];
                            Menu_1 = Cde_Moteurs ;                    
     break;           
// -----------------------------------------------------------------------------------------------------------        
// Visualisation de la position du robot par rapport  la ligne sur l'afficheur 
// -----------------------------------------------------------------------------------------------------------       
     case Visu_Position :   // ------------------------------------------------------------------------------------
                            // Dbut FS11 : Fonction acqurir la position du robot par rapport  la ligne
                            // ------------------------------------------------------------------------------------
                                #if  POSITIONCONNECTEUR == CONNECTEURAR
                                PositionRobotSVL = CalculerValeurCapteurLigne();
                                #else
                                PositionRobotSVL = CalculerValeurCapteurLigne();
                                PositionRobotSVL = AdapterValeurCapteurLigneSiConnecteurAV(PositionRobotSVL);
                                #endif
                                delay_us(1500); 
                            // ------------------------------------------------------------------------------------
                            // Fin FS11       
                            // ------------------------------------------------------------------------------------
                            // Dbut FS13 : Fonction Visualiser (Visualisation de la position des capteurs sur la ligne)
                            // ------------------------------------------------------------------------------------ 
                                if ((Menu_1 != Menu) || (PositionRobotSVL != PositionRobotSVL_1))
                                 {
                                    switch (PositionRobotSVL)              
                                    { 
                                    case POS_HORS_LIGNE:        sprintf(display_buffer_ligne0,"Pos = Hors ligne"); // Hors ligne
                                    break; 
                                    case AR_GAUCHE_OU_AV_DROITE_3PLUS:      sprintf(display_buffer_ligne0,"Pos = Gauche 3+ "); break; // Gauche3+
                                    case AR_GAUCHE_OU_AV_DROITE_2PLUS:      sprintf(display_buffer_ligne0,"Pos = Gauche 2+ "); break; // Gauche2+
                                    case POS_CENTRE_1:                          sprintf(display_buffer_ligne0,"Pos = Centre_1  "); break; // Centre1 non visualis
                                    case AR_GAUCHE_OU_AV_DROITE_PLUS:       sprintf(display_buffer_ligne0,"Pos = Gauche +  "); break; // Gauche+  
                                    case POS_CENTRE_3:                          sprintf(display_buffer_ligne0,"Pos = Centre_3  "); break; // Centre3 
                                    case AR_GAUCHE_OU_AV_DROITE:            sprintf(display_buffer_ligne0,"Pos = Gauche    "); break; // Gauche 
                                    case AR_DROITE_OU_AV_GAUCHE_3PLUS:      sprintf(display_buffer_ligne0,"Pos = Droite 3+ "); break; // Droite3+
                                    case AR_DROITE_OU_AV_GAUCHE_2PLUS:      sprintf(display_buffer_ligne0,"Pos = Droite 2+ "); break; // Droite2+  
                                    case AR_DROITE_OU_AV_GAUCHE_PLUS:       sprintf(display_buffer_ligne0,"Pos = Droite +  "); break; // Droite+ 
                                    case AR_DROITE_OU_AV_GAUCHE:            sprintf(display_buffer_ligne0,"Pos = Droite    "); break; // Droite 
                                    case POS_CENTRE_5:                          sprintf(display_buffer_ligne0,"Pos = Centre_5  "); break; // Centre5 
                                    default:                                sprintf(display_buffer_ligne0,"Pos = ?????     "); // Erreur mesure
                                    }   
                                
                                    sprintf(display_buffer_ligne1,"[%-i]     [ECHAP]",PositionRobotSVL);
                                    Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
                                    PositionRobotSVL_1 = PositionRobotSVL;
                                 } 
                                VisuPositionSurLED = AfficherPositionRobotSVL(PositionRobotSVL);
                                Ecrire_Port_I2C_Soft(Add_LED_I2C,VisuPositionSurLED);  		// Ecriture sur les LED via le bus I2C 
                            
                                if (BP == ECHAP_I2C) Menu = Menu_Test_Capteurs_Ligne; // touche [Echap]
                                            else Menu = Visu_Position;
                          
                                Menu_1 = Visu_Position;
      break;  
// -----------------------------------------------------------------------------------------------------------        
// Test de dtection du capteur cible 
// -----------------------------------------------------------------------------------------------------------  
#if PARCOURS_ROBOT == AVEC_ARRET
      case Visu_Cible:      GICR=0x40; // Activation INT0
                            if ((Menu_1 != Menu)|| (Cible != Cible_1))
                            { 
                            switch (Cible) // Cible passe  1 lorsque le robot est devant la cible  
                              {
                                case 0: sprintf(display_buffer_ligne0,"Regler pos capt.");
                                break;
                                
                                case 1: sprintf(display_buffer_ligne0,"Pos capteur Ok  ");
                                        Cible = 0;   
                                break;     
                              }
                              
                              sprintf(display_buffer_ligne1,"         [ECHAP]");      
                              Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
                              Cible_1 = Cible;
                            }
                        
                            if (BP == ECHAP_I2C)                     // touche [Echap]
                            {
                                 Menu = Menu_Test_Capteurs_Cible; 
                                 Active_Moteurs();  // Ractivation PWM (Dsactive dans l'INT0)
                                 #asm("cli")
                             }
                            else Menu = Visu_Cible;
      
                            Menu_1 = Visu_Cible;
      break; 
      
#elif PARCOURS_ROBOT == SANS_ARRET 
      case Visu_Cible:      if (Menu_1 != Menu)
                            {
                                sprintf(display_buffer_ligne0,"!Test desactive!");
                                sprintf(display_buffer_ligne1,"Compil Avec_Arre"); 
      			    	        Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
      			    	    } 
      			    		if (BP == ECHAP_I2C) 					// touche [Echap]
     							Menu = Menu_Test_Capteurs_Cible; 
     			 	   		else Menu = Visu_Cible;
      
      					    Menu_1 = Visu_Cible;
      break; 
#endif
// -----------------------------------------------------------------------------------------------------------        
// Envoi d'un code (11 bits) sur la liaison IBM
// -----------------------------------------------------------------------------------------------------------        
      case Transm_IBM :  if ((Menu_1 != Menu) || (CodeIBM_1 != CodeIBM) || (AffQuartet_1 != AffQuartet))
                            {
                                sprintf(display_buffer_ligne0,"Code = 0x%-x%-x [%-c]",MSByteIBM,LSByteIBM,AffQuartet);
                                sprintf(display_buffer_ligne1,"[+/-][SET][ECH] ");
                                Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1); 
                                Affiche_Fleche();
                                CodeIBM_1 = CodeIBM; AffQuartet_1 = AffQuartet; 
                            }   
              
                            switch(BP)
                            {
                                case FlecheH_I2C: QuartetIBM = 1; 
                                                  AffQuartet = 'M';   // Slection quartet de poids fort
                                break;                                // de CodeIBM
                                case FlecheB_I2C: QuartetIBM = 0; 
                                                  AffQuartet = 'L';   // Slection quartet de poids faible
                                break;                                // de CodeIBM 
                                
                                case MOINS_I2C: if (QuartetIBM == 1)      // touche [-]
                                                    { 
                                                        if (MSByteIBM > 0) MSByteIBM--; else MSByteIBM = 0;
                                                    } 
                                                else 
                                                    {
                                                        if (LSByteIBM > 0) LSByteIBM--; else LSByteIBM = 0;
                                                    }
                                                CodeIBM =  (MSByteIBM << 4) | LSByteIBM;
                                break;
                                 
                                case PLUS_I2C: if (QuartetIBM == 1)    // touche [+]
                                                    { 
                                                        if (MSByteIBM < 15) MSByteIBM++; else MSByteIBM = 15;
                                                    } 
                                                else 
                                                    {
                                                        if (LSByteIBM < 15) LSByteIBM++; else LSByteIBM = 15;
                                                    }
                                                CodeIBM =  (MSByteIBM << 4) | LSByteIBM;
                                break;
                                 
                                case ECHAP_I2C : CodeIBM = 0; LSByteIBM= 0; MSByteIBM = 0; // touche [Echap]
                                                 Menu = Menu_Test_Transm_IBM; 
                                break; 
                                
                                // Transfert du code en respectant le protocole IBM
                                case SET_I2C : IBMTransfertChar(CodeIBM);
                                break;
                                default: Menu = Transm_IBM ;
                            }
                                                             
                            Menu_1 = Transm_IBM  ;                    
     break;            
// -----------------------------------------------------------------------------------------------------------      
// Fin des tests et rglages avant le dpart 
// -----------------------------------------------------------------------------------------------------------
// !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!        
// Activation d'un parcours  = Dpart !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
// !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! 
// -----------------------------------------------------------------------------------------------------------       
      case Activation :    if ((Menu_1 != Menu) || (decompte != decompte_1))
                            {
                                sprintf(display_buffer_ligne0,"Depart dans %-us",decompte);
                                sprintf(display_buffer_ligne1,"[Ech]>Desactiver");
                                Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
                                decompte_1 = decompte; // Notifie que l'affichage a chang
                            }
                       
                            if (BP==ECHAP_I2C) 
                                {                   // touche [Echap] pour sortir du dcompte
                                                   decompte=5; // Rglage 5s
                                                   Menu=Menu_Reglages;
                                                   break;
                                }
                            else if(decompte == 0)
                                    {   
                                        /*============================================================================================================
                                        // INITIALISATIONS du mode RUN
                                        //------------------------------------------------------------------------------------------------------------                                      
                                        // Initialisation du mode Run (travail lve) => Chargement de la table PWM[][] avec les paramtres sauvegards 
                                        // en EEPROM
                                        // i, k: compteur ligne, j compteur colonne    
                                        // PWM_EEPROM[11,2] contient %Rapports cycliques -->  TABLE_CALCUL_OCRIx[21][2] --> PWM[11][2]
                                        //----------------------------------------------------------------------------------------------------------*/
                                        for (i=0;i<11;i++)          // La valeur de i dpend du nombre de capteurs utiliss
                                        { 
                                        for (j=0;j<2;j++)
                                            { 
                                            for (k=0;k<21;k++)      // La valeur de k dpend du nombre de rglage PWM contenue dans la table
                                                {				    // Table_Calcul_OCR1x situe dans le fichier RB_ELEVE.h 
                                                #if FS12 == SOLUTIONPROF
                                                if (PWM_EEPROM[i][j] == Table_Calcul_OCR1x_PROF[k][0])
                                                    {   
	                                                PWM[i][j] = Table_Calcul_OCR1x_PROF[k][1];
	                                                break;
	                                                }
                                                #else
                                                if (PWM_EEPROM[i][j] == Table_Calcul_OCR1x[k][0])
                                                    {   
	                                                PWM[i][j] = Table_Calcul_OCR1x[k][1];
	                                                break;
	                                                }
                                                #endif
                                                }
                                            }
                                        }  
                                        //------------------------------------------------------------------------------------------------------------ 
                                        // Global enable interrupts
                                        //------------------------------------------------------------------------------------------------------------ 
                                        #if PARCOURS_ROBOT == AVEC_ARRET
                                        #asm("sei") 
                                        #endif
                                        //------------------------------------------------------------------------------------------------------------
                                        // Fin initialisations
                                        //============================================================================================================
                                        // Lien vers le travail Elve  : SOUS-PROGRAMME Mode_RUN()
                                        //------------------------------------------------------------------------------------------------------------
                                        // Appel de la fonction Mode_Run <=> dplacement du robot
                                        //------------------------------------------------------------------------------------------------------------ 
                                        Mode_Run(); // dans fichier RB_ELEVE.c 
                                        //------------------------------------------------------------------------------------------------------------
                                    }                    
                            delay_ms(1000); decompte--;
                            Menu_1 = Activation;
      break; 
                                                           
  } // Fin du switch principal 
//============================================================================================================ 
  Ecrire_Port_I2C_Soft(Add_LED_I2C,~Code_BP); // Visualisation de l'activation d'un BP sur les LED
//============================================================================================================
 } // Fin du while(1)
//============================================================================================================
} // fin du main 
//============================================================================================================  
//============================================================================================================
// Fonction en cours de test
//============================================================================================================
void IBMTransfertChar(unsigned char Valeur) 
{
    unsigned char i;
    unsigned int TrameIBM, LSB; 
 
    ClkIBM = 1;
    DataIBM = 1;
        
    // Prparation de la trame de 11 bits (format IBM PS2)
    TrameIBM = (int)Valeur; 
    TrameIBM = (TrameIBM << 1) | 0b0000010000000000; 

    // Srialisation de la trame de 11 bits
    for (i=0;i<11;i++)
    {    
        LSB = TrameIBM & 0x0001;// LSB = Valeur & 0x0001;
        if (LSB == 0) DataIBM = 0; else DataIBM = 1; // Positionnement de la donne
        delay_us(50);
        ClkIBM = 0;    // front descendant
        delay_us(50);
        ClkIBM = 1;    // front montant
        TrameIBM =  TrameIBM >> 1;
    }
     
    ClkIBM = 1;
    DataIBM = 1;
}
//============================================================================================================